/* GNIO - GLib Network Layer of GIO
 *
 * Copyright (C) 2008 Christian Kellner, Samuel Cormier-Iijima
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors: Christian Kellner <gicmo@gnome.org>
 *          Samuel Cormier-Iijima <sciyoshi@gmail.com>
 */

#ifndef G_NETWORK_OUTPUT_STREAM_H
#define G_NETWORK_OUTPUT_STREAM_H

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define G_TYPE_NETWORK_OUTPUT_STREAM         (g_network_output_stream_get_type ())
#define G_NETWORK_OUTPUT_STREAM(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), G_TYPE_NETWORK_OUTPUT_STREAM, GNetworkOutputStream))
#define G_NETWORK_OUTPUT_STREAM_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), G_TYPE_NETWORK_OUTPUT_STREAM, GNetworkOutputStreamClass))
#define G_IS_NETWORK_OUTPUT_STREAM(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), G_TYPE_NETWORK_OUTPUT_STREAM))
#define G_IS_NETWORK_OUTPUT_STREAM_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), G_TYPE_NETWORK_OUTPUT_STREAM))
#define G_NETWORK_OUTPUT_STREAM_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), G_TYPE_NETWORK_OUTPUT_STREAM, GNetworkOutputStream))

typedef struct _GNetworkOutputStream        GNetworkOutputStream;
typedef struct _GNetworkOutputStreamClass   GNetworkOutputStreamClass;
typedef struct _GNetworkOutputStreamPrivate GNetworkOutputStreamPrivate;

struct _GNetworkOutputStream
{
  GOutputStream parent;

  GNetworkOutputStreamPrivate *priv;
};

struct _GNetworkOutputStreamClass
{
  GOutputStreamClass parent_class;
};

GType                  g_network_output_stream_get_type (void) G_GNUC_CONST;

GNetworkOutputStream * _g_network_output_stream_new     (GSocket *socket);

G_END_DECLS

#endif /* G_NETWORK_OUTPUT_STREAM_H */

